# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/jboss-security-spi/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

%define reltag SP7
%define namedversion %{version}.%{reltag}

Name:           jboss-security-spi
Version:        2.0.4
Release:        5.SP7.1%{?dist}
Epoch:          1
Summary:        JBoss Security SPI
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/security/security-spi/tags/2.0.4.SP7/ jboss-security-spi-2.0.4.SP7
# Exported revision 110785.
# tar cjf jboss-security-spi-2.0.4.SP7.tar.bz2 jboss-security-spi-2.0.4.SP7
Source0:        jboss-security-spi-%{version}.%{reltag}.tar.bz2
Source1:        jboss-security-spi-jpp-depmap.xml
Source2:        jboss-security-spi-settings.xml
Source3:        jboss-security-spi-component-info.xml
Patch0:         jboss-security-spi-pom.patch
Patch1:         jboss-security-spi-as4-pom.patch

Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       jaspi_1_0_api
Requires:       servlet_2_5_api
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  jboss-parent
BuildRequires:  jboss-test
BuildRequires:  junit
BuildRequires:  jaspi_1_0_api
BuildRequires:  servlet_2_5_api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss Security SPI.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n jboss-security-spi-%{namedversion}
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

%{__cp} -p %{SOURCE2} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%patch0 -p1
%patch1 -p1

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__install} -p -m 644 acl/target/acl-spi-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/acl-spi-%{namedversion}.jar
%{__install} -p -m 644 assembly/target/jboss-security-spi-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/jboss-security-spi-%{namedversion}.jar
%{__install} -p -m 644 assembly/target/jboss-security-spi-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/jboss-security-spi-sources-%{namedversion}.jar
%{__install} -p -m 644 authorization/target/authorization-spi-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/authorization-spi-%{namedversion}.jar
%{__install} -p -m 644 identity/target/identity-spi-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/identity-spi-%{namedversion}.jar
%{__install} -p -m 644 jboss-security-spi-as4/target/jboss-security-spi-as4-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/jboss-security-spi-as4-%{namedversion}.jar
%{__install} -p -m 644 spi/target/jboss-security-spi-bare-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/jboss-security-spi-bare-%{namedversion}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%add_to_maven_depmap org.jboss.security jboss-security-spi-pom %{namedversion} JPP/%{name} jboss-security-spi-pom
%{__install} -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-pom.pom
%add_to_maven_depmap org.jboss.security jboss-security-spi-parent %{namedversion} JPP/%{name} jboss-security-spi-parent
%{__install} -p -m 644 parent/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-parent.pom
%add_to_maven_depmap org.jboss.security acl-spi %{namedversion} JPP/%{name} acl-spi
%{__install} -p -m 644 acl/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-acl-spi.pom
%add_to_maven_depmap org.jboss.security %{name} %{namedversion} JPP/%{name} %{name}
%{__install} -p -m 644 assembly/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi.pom
%add_to_maven_depmap org.jboss.security authorization-spi %{namedversion} JPP/%{name} authorization-spi
%{__install} -p -m 644 authorization/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-authorization-spi.pom
%add_to_maven_depmap org.jboss.security identity-spi %{namedversion} JPP/%{name} identity-spi
%{__install} -p -m 644 identity/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-identity-spi.pom
%add_to_maven_depmap org.jboss.security jboss-security-spi-as4 %{namedversion} JPP/%{name} %{name}-as4
%{__install} -p -m 644 jboss-security-spi-as4/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-as4.pom
%add_to_maven_depmap org.jboss.security jboss-security-spi-bare %{namedversion} JPP/%{name} jboss-security-spi-bare
%{__install} -p -m 644 spi/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-bare.pom

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
%{__sed} -i 's/@VERSION@/%{namedversion}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}/jboss-security-spi-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-security-spi.jar
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi.pom %{buildroot}%{repodirlib}/jboss-security-spi.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-parent.pom %{buildroot}%{repodirlib}/jboss-security-spi-parent.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}/jboss-security-spi-sources-%{namedversion}.jar %{buildroot}%{repodirlib}/jboss-security-spi-sources.jar
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}*/%{name}/acl-spi-%{namedversion}.jar
%{_javadir}*/%{name}/acl-spi.jar
%{_javadir}*/%{name}/authorization-spi-%{namedversion}.jar
%{_javadir}*/%{name}/authorization-spi.jar
%{_javadir}*/%{name}/identity-spi-%{namedversion}.jar
%{_javadir}*/%{name}/identity-spi.jar
%{_javadir}*/%{name}/jboss-security-spi-%{namedversion}.jar
# yiwang: add the following jar
%{_javadir}*/%{name}/jboss-security-spi-sources.jar
%{_javadir}*/%{name}/jboss-security-spi-sources-%{namedversion}.jar
%{_javadir}*/%{name}/jboss-security-spi-as4-%{namedversion}.jar
%{_javadir}*/%{name}/jboss-security-spi-as4.jar
%{_javadir}*/%{name}/jboss-security-spi-bare-%{namedversion}.jar
%{_javadir}*/%{name}/jboss-security-spi-bare.jar
%{_javadir}*/%{name}/jboss-security-spi.jar
%{_datadir}/maven2/poms/JPP.%{name}-acl-spi.pom
%{_datadir}/maven2/poms/JPP.%{name}-authorization-spi.pom
%{_datadir}/maven2/poms/JPP.%{name}-identity-spi.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-as4.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-bare.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi-pom.pom
%{_datadir}/maven2/poms/JPP.%{name}-jboss-security-spi.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Feb 25 2011 Martha Benitez <mbenitez@redhat.com> - 1:2.0.4-5.SP7.1
- Upgrade to 2.0.4.SP7
- Add patch to fix version in pom.xml file for AS4 module

* Tue Feb 15 2011 Fernando Nasser <fnasser@redhat.com> - 1:2.0.4-4.SP4.2
- Use jboss-parent 4

* Fri Dec 10 2010 Martha Benitez <mbenitez@redhat.com> - 1:2.0.4-4.SP4.1
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add maven-deploy-plugin, maven-site-plugin

* Fri Jun 04 2010 Martha Benitez <mbenitez@redhat.com> - 1:2.0.4-4.SP4.1
- Upgrading to SP4

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 1:2.0.4-3.SP3.2.2.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 1:2.0.4-3.SP3.2.2
- Rebuild

* Tue Feb 09 2010 Yiqiao Wang <yiwang@redhat.com> 1:2.0.4-3.SP3.2.1
- Merge from RHEL-4
- Add jboss-security-spi-sources.jar under %files

* Mon Feb 08 2010 David Walluck <dwalluck@redhat.com> 1:2.0.4-3.SP3.2
- install parent pom to repolib
- fix file and pom naming

* Fri Feb 05 2010 David Walluck <dwalluck@redhat.com> 1:2.0.4-3.SP3.1
- 2.0.4.SP3
- fix install

* Fri Nov 27 2009 Martha Benitez <mbenitez@redhat.com> 1:2.0.4-2.SP2.1
- Upgrade to 2.0.4.SP2
- Add pom.xml to repolib
- Add sources.jar to main package and repolib

* Mon Sep 21 2009 Fernando Nasser <fnasser@redhat.com> 1:2.0.4-2.SP1.1
- Upgrade to 2.0.4.SP1

* Wed Aug 12 2009 Permaine Cheung <pcheung@redhat.com> 1:2.0.4-1
- Upgrade to 2.0.4

* Thu Jun 18 2009 David Walluck <dwalluck@redhat.com> 1:2.0.3-2.SP1.1
- change versioning scheme because of Fedora
- add repolib

* Fri Jun 12 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.3.1-1.jpp5
- 2.0.3.SP1
